function [fstats] = initialize_fstats(dim_x,dim_alfa,method)
%Initialization of the statistics (fstats) decribing cost function \hat{f}(D).
%
%Arguments:
%   dim_x   : dimension of the observation.
%   dim_alfa: dimension of the hidden representation.
%   method  : method of D optimization, 'BCD' or 'BCDA'.
%----------------------
%Copyright (C) 2012 Zoltan Szabo (szzoli@cs.elte.hu)
%
%This file is part of the OSDL (Online Group-Structured Dictionary Learning) Matlab toolbox.
%
%OSDL is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
%the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
%
%This software is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
%
%You should have received a copy of the GNU General Public License along with OSDL. If not, see <http://www.gnu.org/licenses/>.
%---------------------

switch method
    case 'BCDA'
        fstats.E = zeros(dim_x,dim_alfa);
        fstats.C = zeros(dim_x,dim_alfa);
        fstats.B = zeros(dim_x,dim_alfa);
    case 'BCD'
        fstats.A = zeros(dim_alfa);
        fstats.B = zeros(dim_x,dim_alfa);
    otherwise 
        disp('Error: method=?');
end