function [adj_new] = extend_adj_toroid_by_one_level(adj)
%Extends the adjancency matrix of toroid structure by one level = "takes the neigbors of the neighbors".
%----------------------
%Copyright (C) 2012 Zoltan Szabo (szzoli@cs.elte.hu)
%
%This file is part of the OSDL (Online Group-Structured Dictionary Learning) Matlab toolbox.
%
%OSDL is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
%the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
%
%This software is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
%
%You should have received a copy of the GNU General Public License along with OSDL. If not, see <http://www.gnu.org/licenses/>.
%---------------------

%initialization:
    K = size(adj,1);
    adj_new = adj;

for k = 1 : K
    neighs_of_k = find(adj(:,k));%indices
    for k2 = 1 : length(neighs_of_k)
        neighs_of_k2 = find(adj(:,neighs_of_k(k2)));%indices
        adj_new(neighs_of_k2,k) = 1;
    end
end